<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="de">
<head>
<!-- Generated by javadoc -->
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>XPathExpressionEngine (Apache Commons Configuration 2.2 API)</title>
<link rel="stylesheet" type="text/css" href="../../../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="XPathExpressionEngine (Apache Commons Configuration 2.2 API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/XPathExpressionEngine.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../../org/apache/commons/configuration2/tree/xpath/ConfigurationNodePointerFactory.html" title="class in org.apache.commons.configuration2.tree.xpath"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li>Next&nbsp;Class</li>
</ul>
<ul class="navList">
<li><a href="../../../../../../index.html?org/apache/commons/configuration2/tree/xpath/XPathExpressionEngine.html" target="_top">Frames</a></li>
<li><a href="XPathExpressionEngine.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.apache.commons.configuration2.tree.xpath</div>
<h2 title="Class XPathExpressionEngine" class="title">Class XPathExpressionEngine</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">java.lang.Object</a></li>
<li>
<ul class="inheritance">
<li>org.apache.commons.configuration2.tree.xpath.XPathExpressionEngine</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><a href="../../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html" title="interface in org.apache.commons.configuration2.tree">ExpressionEngine</a></dd>
</dl>
<hr>
<br>
<pre>public class <span class="typeNameLabel">XPathExpressionEngine</span>
extends <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>
implements <a href="../../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html" title="interface in org.apache.commons.configuration2.tree">ExpressionEngine</a></pre>
<div class="block"><p>
 A specialized implementation of the <code>ExpressionEngine</code> interface that
 is able to evaluate XPATH expressions.
 </p>
 <p>
 This class makes use of <a href="http://commons.apache.org/jxpath/"> Commons
 JXPath</a> for handling XPath expressions and mapping them to the nodes of a
 hierarchical configuration. This makes the rich and powerful XPATH syntax
 available for accessing properties from a configuration object.
 </p>
 <p>
 For selecting properties arbitrary XPATH expressions can be used, which
 select single or multiple configuration nodes. The associated
 <code>Configuration</code> instance will directly pass the specified property keys
 into this engine. If a key is not syntactically correct, an exception will be
 thrown.
 </p>
 <p>
 For adding new properties, this expression engine uses a specific syntax: the
 &quot;key&quot; of a new property must consist of two parts that are
 separated by whitespace:
 </p>
 <ol>
 <li>An XPATH expression selecting a single node, to which the new element(s)
 are to be added. This can be an arbitrary complex expression, but it must
 select exactly one node, otherwise an exception will be thrown.</li>
 <li>The name of the new element(s) to be added below this parent node. Here
 either a single node name or a complete path of nodes (separated by the
 &quot;/&quot; character or &quot;@&quot; for an attribute) can be specified.</li>
 </ol>
 <p>
 Some examples for valid keys that can be passed into the configuration's
 <code>addProperty()</code> method follow:
 </p>

 <pre>
 &quot;/tables/table[1] type&quot;
 </pre>

 <p>
 This will add a new <code>type</code> node as a child of the first <code>table</code>
 element.
 </p>

 <pre>
 &quot;/tables/table[1] @type&quot;
 </pre>

 <p>
 Similar to the example above, but this time a new attribute named
 <code>type</code> will be added to the first <code>table</code> element.
 </p>

 <pre>
 &quot;/tables table/fields/field/name&quot;
 </pre>

 <p>
 This example shows how a complex path can be added. Parent node is the
 <code>tables</code> element. Here a new branch consisting of the nodes
 <code>table</code>, <code>fields</code>, <code>field</code>, and <code>name</code> will be added.
 </p>

 <pre>
 &quot;/tables table/fields/field@type&quot;
 </pre>

 <p>
 This is similar to the last example, but in this case a complex path ending
 with an attribute is defined.
 </p>
 <p>
 <strong>Note:</strong> This extended syntax for adding properties only works
 with the <code>addProperty()</code> method. <code>setProperty()</code> does not support
 creating new nodes this way.
 </p>
 <p>
 From version 1.7 on, it is possible to use regular keys in calls to
 <code>addProperty()</code> (i.e. keys that do not have to contain a whitespace as
 delimiter). In this case the key is evaluated, and the biggest part pointing
 to an existing node is determined. The remaining part is then added as new
 path. As an example consider the key
 </p>

 <pre>
 &quot;tables/table[last()]/fields/field/name&quot;
 </pre>

 <p>
 If the key does not point to an existing node, the engine will check the
 paths <code>"tables/table[last()]/fields/field"</code>,
 <code>"tables/table[last()]/fields"</code>, <code>"tables/table[last()]"</code>, and so
 on, until a key is found which points to a node. Let's assume that the last
 key listed above can be resolved in this way. Then from this key the
 following key is derived: <code>"tables/table[last()] fields/field/name"</code> by
 appending the remaining part after a whitespace. This key can now be
 processed using the original algorithm. Keys of this form can also be used
 with the <code>setProperty()</code> method. However, it is still recommended to
 use the old format because it makes explicit at which position new nodes
 should be added. For keys without a whitespace delimiter there may be
 ambiguities.
 </p></div>
<dl>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>1.3</dd>
<dt><span class="simpleTagLabel">Version:</span></dt>
<dd>$Id: XPathExpressionEngine.java 1790899 2017-04-10 21:56:46Z ggregory $</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../../../org/apache/commons/configuration2/tree/xpath/XPathExpressionEngine.html#XPathExpressionEngine--">XPathExpressionEngine</a></span>()</code>
<div class="block">Creates a new instance of <code>XPathExpressionEngine</code> with default
 settings.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../../org/apache/commons/configuration2/tree/xpath/XPathExpressionEngine.html#attributeKey-java.lang.String-java.lang.String-">attributeKey</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;parentKey,
            <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;attributeName)</code>
<div class="block">Returns the key of an attribute.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../../org/apache/commons/configuration2/tree/xpath/XPathExpressionEngine.html#canonicalKey-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">canonicalKey</a></span>(T&nbsp;node,
            <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;parentKey,
            <a href="../../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</code>
<div class="block">Determines a &quot;canonical&quot; key for the specified node in the
 expression language supported by this implementation.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../../org/apache/commons/configuration2/tree/xpath/XPathExpressionEngine.html#nodeKey-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">nodeKey</a></span>(T&nbsp;node,
       <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;parentKey,
       <a href="../../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</code>
<div class="block">Returns the key for the specified node in the expression language
 supported by an implementation.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;<a href="../../../../../../org/apache/commons/configuration2/tree/NodeAddData.html" title="class in org.apache.commons.configuration2.tree">NodeAddData</a>&lt;T&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../../org/apache/commons/configuration2/tree/xpath/XPathExpressionEngine.html#prepareAdd-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">prepareAdd</a></span>(T&nbsp;root,
          <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
          <a href="../../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</code>
<div class="block">Returns information needed for an add operation.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/util/List.html?is-external=true" title="class or interface in java.util">List</a>&lt;<a href="../../../../../../org/apache/commons/configuration2/tree/QueryResult.html" title="class in org.apache.commons.configuration2.tree">QueryResult</a>&lt;T&gt;&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../../org/apache/commons/configuration2/tree/xpath/XPathExpressionEngine.html#query-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">query</a></span>(T&nbsp;root,
     <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
     <a href="../../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</code>
<div class="block">Finds the nodes and/or attributes that are matched by the specified key.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></h3>
<code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#clone--" title="class or interface in java.lang">clone</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#equals-java.lang.Object-" title="class or interface in java.lang">equals</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#finalize--" title="class or interface in java.lang">finalize</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#getClass--" title="class or interface in java.lang">getClass</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#hashCode--" title="class or interface in java.lang">hashCode</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#notify--" title="class or interface in java.lang">notify</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#notifyAll--" title="class or interface in java.lang">notifyAll</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#toString--" title="class or interface in java.lang">toString</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait--" title="class or interface in java.lang">wait</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait-long-" title="class or interface in java.lang">wait</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait-long-int-" title="class or interface in java.lang">wait</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="XPathExpressionEngine--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>XPathExpressionEngine</h4>
<pre>public&nbsp;XPathExpressionEngine()</pre>
<div class="block">Creates a new instance of <code>XPathExpressionEngine</code> with default
 settings.</div>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="query-java.lang.Object-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a><a name="query-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>query</h4>
<pre>public&nbsp;&lt;T&gt;&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/util/List.html?is-external=true" title="class or interface in java.util">List</a>&lt;<a href="../../../../../../org/apache/commons/configuration2/tree/QueryResult.html" title="class in org.apache.commons.configuration2.tree">QueryResult</a>&lt;T&gt;&gt;&nbsp;query(T&nbsp;root,
                                      <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
                                      <a href="../../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</pre>
<div class="block">Finds the nodes and/or attributes that are matched by the specified key.
 This is the main method for interpreting property keys. An implementation
 must traverse the given root node and its children to find all results
 that are matched by the given key. If the key is not correct in the
 syntax provided by that implementation, it is free to throw a (runtime)
 exception indicating this error condition. The passed in
 <code>NodeHandler</code> can be used to gather the required information from
 the node object. This implementation interprets the passed in key as an XPATH
 expression.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html#query-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">query</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html" title="interface in org.apache.commons.configuration2.tree">ExpressionEngine</a></code></dd>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - the type of the node to be processed</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>root</code> - the root node of a hierarchy of nodes</dd>
<dd><code>key</code> - the key to be evaluated</dd>
<dd><code>handler</code> - the <code>NodeHandler</code> for accessing the node</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a list with the results that are matched by the key (should never
         be <b>null</b>)</dd>
</dl>
</li>
</ul>
<a name="nodeKey-java.lang.Object-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a><a name="nodeKey-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>nodeKey</h4>
<pre>public&nbsp;&lt;T&gt;&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;nodeKey(T&nbsp;node,
                          <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;parentKey,
                          <a href="../../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</pre>
<div class="block">Returns the key for the specified node in the expression language
 supported by an implementation. This method is called whenever a property
 key for a node has to be constructed, e.g. by the
 <a href="../../../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getKeys--"><code>getKeys()</code></a> method. This implementation creates an XPATH expression that
 selects the given node (under the assumption that the passed in parent
 key is valid). As the <code>nodeKey()</code> implementation of
 <a href="../../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngine.html" title="class in org.apache.commons.configuration2.tree"><code>DefaultExpressionEngine</code></a> this method does not return indices for nodes.
 So all child nodes of a given parent with the same name have the same
 key.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html#nodeKey-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">nodeKey</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html" title="interface in org.apache.commons.configuration2.tree">ExpressionEngine</a></code></dd>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - the type of the node to be processed</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>node</code> - the node, for which the key must be constructed</dd>
<dd><code>parentKey</code> - the key of this node's parent (can be <b>null</b> for
        the root node)</dd>
<dd><code>handler</code> - the <code>NodeHandler</code> for accessing the node</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>this node's key</dd>
</dl>
</li>
</ul>
<a name="attributeKey-java.lang.String-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>attributeKey</h4>
<pre>public&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;attributeKey(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;parentKey,
                           <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;attributeName)</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html#attributeKey-java.lang.String-java.lang.String-">ExpressionEngine</a></code></span></div>
<div class="block">Returns the key of an attribute. The passed in <code>parentKey</code> must
 reference the parent node of the attribute. A concrete implementation
 must concatenate this parent key with the attribute name to a valid key
 for this attribute.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html#attributeKey-java.lang.String-java.lang.String-">attributeKey</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html" title="interface in org.apache.commons.configuration2.tree">ExpressionEngine</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>parentKey</code> - the key to the node owning this attribute</dd>
<dd><code>attributeName</code> - the name of the attribute in question</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the resulting key referencing this attribute</dd>
</dl>
</li>
</ul>
<a name="canonicalKey-java.lang.Object-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a><a name="canonicalKey-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>canonicalKey</h4>
<pre>public&nbsp;&lt;T&gt;&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;canonicalKey(T&nbsp;node,
                               <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;parentKey,
                               <a href="../../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</pre>
<div class="block">Determines a &quot;canonical&quot; key for the specified node in the
 expression language supported by this implementation. This means that
 always a unique key if generated pointing to this specific node. For most
 concrete implementations, this means that an index is added to the node
 name to ensure that there are no ambiguities with child nodes having the
 same names. This implementation works similar to <code>nodeKey()</code>, but
 always adds an index expression to the resulting key.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html#canonicalKey-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">canonicalKey</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html" title="interface in org.apache.commons.configuration2.tree">ExpressionEngine</a></code></dd>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - the type of the node to be processed</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>node</code> - the node, for which the key must be constructed</dd>
<dd><code>parentKey</code> - the key of this node's parent (can be <b>null</b> for
        the root node)</dd>
<dd><code>handler</code> - the <code>NodeHandler</code> for accessing the node</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the canonical key of this node</dd>
</dl>
</li>
</ul>
<a name="prepareAdd-java.lang.Object-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a><a name="prepareAdd-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>prepareAdd</h4>
<pre>public&nbsp;&lt;T&gt;&nbsp;<a href="../../../../../../org/apache/commons/configuration2/tree/NodeAddData.html" title="class in org.apache.commons.configuration2.tree">NodeAddData</a>&lt;T&gt;&nbsp;prepareAdd(T&nbsp;root,
                                     <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
                                     <a href="../../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</pre>
<div class="block">Returns information needed for an add operation. This method gets called
 when new properties are to be added to a configuration. An implementation
 has to interpret the specified key, find the parent node for the new
 elements, and provide all information about new nodes to be added. The expected format of the passed in key is explained in
 the class comment.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html#prepareAdd-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">prepareAdd</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html" title="interface in org.apache.commons.configuration2.tree">ExpressionEngine</a></code></dd>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - the type of the node to be processed</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>root</code> - the root node</dd>
<dd><code>key</code> - the key for the new property</dd>
<dd><code>handler</code> - the <code>NodeHandler</code> for accessing the node</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>an object with all information needed for the add operation</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/XPathExpressionEngine.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../../org/apache/commons/configuration2/tree/xpath/ConfigurationNodePointerFactory.html" title="class in org.apache.commons.configuration2.tree.xpath"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li>Next&nbsp;Class</li>
</ul>
<ul class="navList">
<li><a href="../../../../../../index.html?org/apache/commons/configuration2/tree/xpath/XPathExpressionEngine.html" target="_top">Frames</a></li>
<li><a href="XPathExpressionEngine.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small>Copyright &#169; 2001&#x2013;2017 <a href="https://www.apache.org/">The Apache Software Foundation</a>. All rights reserved.</small></p>
</body>
</html>
